<template>
	<f7-page no-toolbar no-navbar no-swipeback login-screen>
		<f7-block>
			<img :src="require('../assets/logo-text-only.png')" width="100">
			<div v-if="authStatus == 'login'">
				<f7-login-screen-title class="text-align-left no-margin-bottom">Selamat Datang!</f7-login-screen-title>
				<p class="login-screen-hint">Silahkan masuk menggunakan No. Handphone anda.</p>
				<f7-list form class="no-hairlines-between">
					<f7-list-input
						class="text-normal"
						ref="identity"
						label="No. Handphone"
						type="number"
						placeholder="Masukkan No. Handphone"
						:value="loginForm.identity"
						@input="loginForm.identity = $event.target.value">
					</f7-list-input>				
				</f7-list>
				<f7-block class="margin-small-top no-padding">
					<f7-button @click="doLogin" fill-ios round-ios color="white" icon-f7="arrow_right" class="button-auto gradient-button text-align-left" large>Masuk</f7-button>
				</f7-block>
				<f7-block class="margin-small-top no-padding">
					<p>Belum punya akun? Silahkan <f7-link href="#" @click="setRegister">Daftar Sekarang!</f7-link></p>
				</f7-block>
			</div>
			<div v-else-if="authStatus == 'register'">
				<f7-login-screen-title class="text-align-left no-margin-bottom">Selamat Datang!</f7-login-screen-title>
				<p class="login-screen-hint">Silahkan isi data anda untuk mendaftar akun RingSatu.</p>
				<f7-list form class="no-hairlines-between">
					<f7-list-input
						class="text-normal"
						ref="fullname"
						label="Nama Lengkap"
						type="text"
						placeholder="Masukkan nama lengkap anda"
						:value="registerForm.fullname"
						@input="registerForm.fullname = $event.target.value">
					</f7-list-input>
					<f7-list-input
						class="text-normal"
						ref="phone"
						label="No. Handphone"
						type="number"
						placeholder="Masukkan No. Handphone"
						:value="registerForm.phone"
						@input="registerForm.phone = $event.target.value">
					</f7-list-input>				
				</f7-list>
				<f7-block class="margin-small-top no-padding">
					<f7-button @click="doRegister" fill-ios round-ios color="white" icon-f7="arrow_right" class="button-auto gradient-button text-align-left" large>Daftar</f7-button>
				</f7-block>
				<f7-block class="margin-small-top no-padding">
					<p>Sudah punya akun? Silahkan <f7-link href="#" @click="setLogin">Masuk</f7-link></p>
				</f7-block>
			</div>
			<div v-else-if="authStatus == 'verify'">
				<f7-login-screen-title class="text-align-left no-margin-bottom">Verifikasi Akun</f7-login-screen-title>
				<p class="login-screen-hint">Masukkan 6 digit SMS OTP yang kami kirimkan ke handphone anda.</p>
				<f7-list form class="no-hairlines-between">
					<f7-list-input
						ref="passkey"
						label="Kode OTP"
						placeholder="••••••"
						:value="verifyForm.passkey"
						@input="verifyForm.passkey = $event.target.value"
						minlength="1"
						maxlength="6">
						<span slot="content-end" style="width:80px;">
							<strong>
								<countdown ref="countdown" v-if="counting" :time="300000" :transform="transform" @end="handleCountdownEnd">
									<template slot-scope="props">{{ props.minutes }} : {{ props.seconds }}</template>
								</countdown>
								<span v-else>00:00</span>
							</strong>
						</span>
					</f7-list-input>				
				</f7-list>
				<f7-block class="margin-small-top no-padding">
					<f7-row>
						<f7-col>
							<f7-button @click="doVerify" fill-ios round-ios color="white" icon-f7="arrow_right" class="button-auto gradient-button text-align-left margin-small-right" large>Verifikasi</f7-button>
						</f7-col>
						<f7-col>
							<f7-button class="display-inline-block margin-small-top" @click="doReverify" :disabled="counting">Kirim ulang SMS OTP</f7-button>
						</f7-col>
					</f7-row>
				</f7-block>
			</div>
		</f7-block>
	</f7-page>
</template>

<script>
import { mapGetters } from 'vuex';
import { parseError } from '../js/utils'
export default {
	name: 'AuthLogin',
	data() {
		return {
			loginForm: {
				identity: ''
			},
			registerForm: {
				fullname: '',
				phone: ''
			},
			verifyForm: {
				passkey: ''
			},
			counting: false
		};
	},
	computed: {
		...mapGetters('auth', [
			'authStatus',
			'verificationCode'
		])
	},
	methods: {
		transform(props) {
			Object.entries(props).forEach(([key, value]) => {
				const digits = value < 10 ? `0${value}` : value;
				props[key] = `${digits}`;
			});
			return props;
		},
		handleCountdownEnd(){
			this.counting = false;
		},
		setLogin(){
			const self = this;

			self.$store.dispatch('auth/setLogin');
		},
		setRegister(){
			const self = this;

			self.$store.dispatch('auth/setRegister');
		},
		doLogin() {
			const self = this;
			const app = self.$f7;
			const router = self.$f7router;

			let identity = self.loginForm.identity;

			if(identity.trim().length == 0){
				app.dialog.alert('Silahkan isi No. Handphone', 'RingSatu');
				return false;
			}else if(/\(?(?:\+628|628|08)(?:\d{2,3})?\)?[ .-]?\d{2,4}[ .-]?\d{2,4}[ .-]?\d{2,4}/.test(identity) == false){
				app.dialog.alert('Format No. Handphone tidak valid', 'RingSatu');
				return false;
			}

			app.preloader.show('green');
			
			self.$store.dispatch('auth/doLogin', {
				identity: identity,
				ui: 'mobile'
			}).then((response) => {
				app.preloader.hide();

				if('errors' in response){
					const error = parseError(response.errors)
					app.dialog.alert(error.messages, 'RingSatu');
					return false;
				}else{
					self.verifyForm.passkey = '';
					self.counting = true;
				}
			});
		},
		doRegister() {
			const self = this;
			const app = self.$f7;
			const router = self.$f7router;

			let phone = self.registerForm.phone;
			let fullname = self.registerForm.fullname;

			if(fullname.trim().length == 0){
				app.dialog.alert('Silahkan isi nama lengkap', 'RingSatu');
				return false;
			}else if(/^([a-zA-Z0-9\s]{1,255})$/.test(fullname) == false){
				app.dialog.alert('Nama lengkap hanya boleh menggunakan huruf, angka dan spasi', 'RingSatu');
				return false;
			}else if(phone.trim().length == 0){
				app.dialog.alert('Silahkan isi No. Handphone', 'RingSatu');
				return false;
			}else if(/\(?(?:\+628|628|08)(?:\d{2,3})?\)?[ .-]?\d{2,4}[ .-]?\d{2,4}[ .-]?\d{2,4}/.test(phone) == false){
				app.dialog.alert('Format No. Handphone tidak valid', 'RingSatu');
				return false;
			}

			app.preloader.show('green');
			
			self.$store.dispatch('auth/doRegister', {
				phone: phone,
				fullname: fullname
			}).then((response) => {
				app.preloader.hide();

				if('errors' in response){
					const error = parseError(response.errors)
					app.dialog.alert(error.messages, 'RingSatu');
					return false;
				}else{
					self.registerForm = {
						fullname: '',
						phone: ''
					};
				}
			});
		},
		doVerify(){
			const self = this;
			const app = self.$f7;
			const router = self.$f7router;

			let passkey = self.verifyForm.passkey;

			if(passkey.trim().length == 0){
				app.dialog.alert('Silahkan masukkan 6 digit SMS OTP');
				return false;
			}

			app.preloader.show('green');

			self.$store.dispatch('auth/doVerify', {
				passkey: passkey,
				code: self.verificationCode.code,
				exclude: 'role.permissions,parents.childs,parents.role.permissions'
			}).then((response) => {			
				if('errors' in response){
					const error = parseError(response.errors);
					app.preloader.hide();
					app.dialog.alert(error.messages);
					return false;
				}else{
					self.loginForm.indentity = '';
					self.counting = true;

					self.$store.dispatch('addDevice').then((response)=>{
						app.preloader.hide();
						// self.$f7router.refreshPage('/', {
						// 	ignoreCache: true,
        				// 	reloadAll: true
						// });
						location.reload();
					}).catch((err)=>{
						location.reload();
					});					
				}
			});
		},
		doReverify(){
			const self = this;
			const app = self.$f7;
			const router = self.$f7router;

			app.preloader.show('green');

			self.$store.dispatch('auth/doReverify', {
				code: self.verificationCode.code
			}).then((response) => {		
				app.preloader.hide();	
				if('errors' in response){
					const error = parseError(response.errors);
					app.preloader.hide();
					app.dialog.alert(error.messages);
					return false;
				}
			});
		}
	}
};
</script>